Use regular POST (non-ajax) for wiki preview
2008-09-04 02:33 - Jim Jones
Target version:

Resolution: Wont fix Affected version:

Description

I'm filing this as a bug because it has bitten me for the third time and I'm certainly not alone.

Currently the wiki preview is AJAXified, this makes it very easy to lose all your work in progress by performing one of the following
actions by accident:

e Hit the back-button
e Middle click anywhere outside the textarea (middle-click means "load URL in copy-buffer" in most browser)

Commonly you'll spend quite some time in the edit/preview cycle before saving a new revision. Losing all changes to a single
misclick is a very frustrating expirience.

| propose the following fixes:
¢ Replace the AJAX preview with a normal POST-preview or at least add the POST-preview as an option

e Use javascript to display a warning dialog when the back-button is pressed (Note: This does not prevent the middle-click
accident)

Related issues:
Related to Redmine - Feature #2910: Warning on leaving edited issue/wiki page... Closed 2009-03-05

History

#1 - 2008-09-04 23:56 - Alteran Ancient

How about add some javascript to bring-up a verification message if the user attempts the following, in the belief that they could be doing-so by
accident.

#2 - 2008-09-05 00:21 - Jim Jones

Alteran Ancient wrote:
How about add some javascript to bring-up a verification message if the user attempts the following, in the belief that they could be doing-so by
accident.

If all possible user mistakes can be caught with javascript then I'm fine with that.

But | think at least the middle-click issue is hard to detect.

Frankly, there should just be a straight, non-AJAX preview. AJAX can be helpful and nice - but not in this case.

#3 - 2008-09-05 08:40 - Paul Rivier

Jim Jones wrote:

Frankly, there should just be a straight, non-AJAX preview. AJAX can be helpful and nice - but not in this case.

How is that related to the use of ajax ?

#4 - 2008-09-05 15:39 - Jim Jones

Paul Rivier wrote:

Jim Jones wrote:
Frankly, there should just be a straight, non-AJAX preview. AJAX can be helpful and nice - but not in this case.

How is that related to the use of ajax ?

Try it:

1. Start editing a wiki-page in redmine

2. Enter some characters

3. Hit the preview-link

4. Hit the browser back-button (or navigate away from that page by other means)
5. Hit the browser forward-button

Result: All your editing is lost irrecoverably.

Counter-example:
1. Go to any website that implements regular POST-preview, e.g.: http:/moinmo.in/WikiSandBox
2. Start editing that page

3. Hit the preview-link
4. Hit the browser back- and forward-buttons in any order you like

Result: There is no way to lose your edit-buffer after having pressed "Preview" at least once. Firefox even remembers it across browser crashes.

To clarify again: This is not cosmetics, it's a serious usability issue. Imagine deploying redmine to a non-technical audience (e.g. for company-wide
use). Now imagine having to explain why your boss just lost half an hour of editing only because he hit the back-button by accident.

Ofcourse the same problem applies to the ticket editing and any other area where AJAX-preview is used as well. | think it's not as serious of a

problem there because you don't normally go through the edit/preview cycle as often as with a wiki-page, thus accidents are less likely to happen.
Nonetheless it would ofcourse be advisable to fix this problem across all of redmine, for consistency.

#5 - 2009-06-09 11:51 - Péter Major
Hi,

True, it's very hard to use the editor like this, but nothing happened since 9 months. :(
Any progress or something??

#6 - 2010-12-21 08:21 - Andreas Huggel
ping

#7 - 2010-12-21 23:58 - Terence Mill
Duplicate of Issue #2910.

Checkout Drafts plugin

#8 - 2010-12-23 16:45 - Jean-Philippe Lang

- Subject changed from Wiki AJAX preview is a bad idea to Use regular POST (non-ajax) for wiki preview

I've already been hit by this problem but using a standard POST for preview would have disadvantages as well:
e attachments would be uselessly uploaded are more than that, you'd lost your attachments selection
¢ you'd lost the current textarea position (can be really annoying when editing long text)

® slower previews

| think that a javascript warning when leaving the page without saving would be a good option.

#9 - 2010-12-23 18:35 - Mischa The Evil

Jean-Philippe Lang wrote:

(-]

| think that a javascript warning when leaving the page without saving would be a good option.

I'd vote +1 for that solution to this persistent issue, seeing all the related issues.

#10 - 2010-12-24 12:09 - Terence Mill
http://moinmo.in/WikiSandBox
https://www.redmine.org/issues/2910
http://www.redmine.org/boards/3/topics/13930

| think that a javascript warning when leaving the page without saving would be a good option.

+1

#11 - 2010-12-29 22:07 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Wont fix

Thanks for the feedback. I'm closing this in favor of #2910 planned for 1.2.0.
